# CfnTask

The `AWS::DataSync::Task` resource specifies a task.

A task is a set of two locations (source and destination) and a set of `Options` that you use to control the behavior of a task. If you don't specify `Options` when you create a task, AWS DataSync populates them with service defaults.

Extends: Construct › CfnElement › CfnRefElement › CfnResource › CfnTask
Implements: IInspectable, ITaggable, IEnvironmentAware, ITaskRef, IConstruct, IDependable

- CloudFormation: [`AWS::DataSync::Task`](https://docs.aws.amazon.com/AWSCloudFormation/latest/TemplateReference/aws-resource-datasync-task.html)
- Source: Generated code
- Type last changed: v2.252.0 · 30 Apr 2026

## Example

```ts
// The code below shows an example of how to instantiate this type.
// The values are placeholders you should change.
import { aws_datasync as datasync } from 'aws-cdk-lib';
const cfnTask = new datasync.CfnTask(this, 'MyCfnTask', {
  destinationLocationArn: 'destinationLocationArn',
  sourceLocationArn: 'sourceLocationArn',

  // the properties below are optional
  cloudWatchLogGroupArn: 'cloudWatchLogGroupArn',
  excludes: [{
    filterType: 'filterType',
    value: 'value',
  }],
  includes: [{
    filterType: 'filterType',
    value: 'value',
  }],
  manifestConfig: {
    source: {
      s3: {
        bucketAccessRoleArn: 'bucketAccessRoleArn',
        manifestObjectPath: 'manifestObjectPath',
        manifestObjectVersionId: 'manifestObjectVersionId',
        s3BucketArn: 's3BucketArn',
      },
    },

    // the properties below are optional
    action: 'action',
    format: 'format',
  },
  name: 'name',
  options: {
    atime: 'atime',
    bytesPerSecond: 123,
    gid: 'gid',
    logLevel: 'logLevel',
    mtime: 'mtime',
    objectMetadata: 'objectMetadata',
    objectTags: 'objectTags',
    overwriteMode: 'overwriteMode',
    posixPermissions: 'posixPermissions',
    preserveDeletedFiles: 'preserveDeletedFiles',
    preserveDevices: 'preserveDevices',
    securityDescriptorCopyFlags: 'securityDescriptorCopyFlags',
    taskQueueing: 'taskQueueing',
    transferMode: 'transferMode',
    uid: 'uid',
    verifyMode: 'verifyMode',
  },
  schedule: {
    scheduleExpression: 'scheduleExpression',
    status: 'status',
  },
  tags: [{
    key: 'key',
    value: 'value',
  }],
  taskMode: 'taskMode',
  taskReportConfig: {
    destination: {
      s3: {
        bucketAccessRoleArn: 'bucketAccessRoleArn',
        s3BucketArn: 's3BucketArn',
        subdirectory: 'subdirectory',
      },
    },
    outputType: 'outputType',

    // the properties below are optional
    objectVersionIds: 'objectVersionIds',
    overrides: {
      deleted: {
        reportLevel: 'reportLevel',
      },
      skipped: {
        reportLevel: 'reportLevel',
      },
      transferred: {
        reportLevel: 'reportLevel',
      },
      verified: {
        reportLevel: 'reportLevel',
      },
    },
    reportLevel: 'reportLevel',
  },
});
```

## Initializer

```ts
new CfnTask(scope: Construct, id: string, props: CfnTaskProps)
```

## Construct Props

- `cloudWatchLogGroupArn`: string | [ILogGroupRef](/cdk/api/v2/docs/aws-cdk-lib.interfaces.aws_logs.ILogGroupRef.html) — Specifies the Amazon Resource Name (ARN) of an Amazon CloudWatch log group for monitoring your task.

  For Enhanced mode tasks, you don't need to specify anything. DataSync automatically sends logs to a CloudWatch log group named `/aws/datasync` .

  For more information, see [Monitoring data transfers with CloudWatch Logs](https://docs.aws.amazon.com/datasync/latest/userguide/configure-logging.html) .

- `destinationLocationArn`: string | [ILocationEFSRef](/cdk/api/v2/docs/aws-cdk-lib.interfaces.aws_datasync.ILocationEFSRef.html) | [ILocationS3Ref](/cdk/api/v2/docs/aws-cdk-lib.interfaces.aws_datasync.ILocationS3Ref.html) (required) — The Amazon Resource Name (ARN) of an AWS storage resource's location.

- `excludes`: [IResolvable](/cdk/api/v2/docs/aws-cdk-lib.IResolvable.html) | [IResolvable](/cdk/api/v2/docs/aws-cdk-lib.IResolvable.html) | [CfnTask.FilterRuleProperty](/cdk/api/v2/docs/aws-cdk-lib.aws_datasync.CfnTask.FilterRuleProperty.html)[] — Specifies exclude filters that define the files, objects, and folders in your source location that you don't want DataSync to transfer.

  For more information and examples, see [Specifying what DataSync transfers by using filters](https://docs.aws.amazon.com/datasync/latest/userguide/filtering.html) .

- `includes`: [IResolvable](/cdk/api/v2/docs/aws-cdk-lib.IResolvable.html) | [IResolvable](/cdk/api/v2/docs/aws-cdk-lib.IResolvable.html) | [CfnTask.FilterRuleProperty](/cdk/api/v2/docs/aws-cdk-lib.aws_datasync.CfnTask.FilterRuleProperty.html)[] — Specifies include filters that define the files, objects, and folders in your source location that you want DataSync to transfer.

  For more information and examples, see [Specifying what DataSync transfers by using filters](https://docs.aws.amazon.com/datasync/latest/userguide/filtering.html) .

- `manifestConfig`: [IResolvable](/cdk/api/v2/docs/aws-cdk-lib.IResolvable.html) | [CfnTask.ManifestConfigProperty](/cdk/api/v2/docs/aws-cdk-lib.aws_datasync.CfnTask.ManifestConfigProperty.html) — The configuration of the manifest that lists the files or objects that you want DataSync to transfer.

  For more information, see [Specifying what DataSync transfers by using a manifest](https://docs.aws.amazon.com/datasync/latest/userguide/transferring-with-manifest.html) .

- `name`: string — Specifies the name of your task.

- `options`: [IResolvable](/cdk/api/v2/docs/aws-cdk-lib.IResolvable.html) | [CfnTask.OptionsProperty](/cdk/api/v2/docs/aws-cdk-lib.aws_datasync.CfnTask.OptionsProperty.html) — Specifies your task's settings, such as preserving file metadata, verifying data integrity, among other options.

- `schedule`: [IResolvable](/cdk/api/v2/docs/aws-cdk-lib.IResolvable.html) | [CfnTask.TaskScheduleProperty](/cdk/api/v2/docs/aws-cdk-lib.aws_datasync.CfnTask.TaskScheduleProperty.html) — Specifies a schedule for when you want your task to run.

  For more information, see [Scheduling your task](https://docs.aws.amazon.com/datasync/latest/userguide/task-scheduling.html) .

- `sourceLocationArn`: string | [ILocationNFSRef](/cdk/api/v2/docs/aws-cdk-lib.interfaces.aws_datasync.ILocationNFSRef.html) | [ILocationS3Ref](/cdk/api/v2/docs/aws-cdk-lib.interfaces.aws_datasync.ILocationS3Ref.html) (required) — Specifies the ARN of your transfer's source location.

- `tags`: [CfnTag](/cdk/api/v2/docs/aws-cdk-lib.CfnTag.html)[] — Specifies the tags that you want to apply to your task.

  *Tags* are key-value pairs that help you manage, filter, and search for your DataSync resources.

- `taskMode`: string — The task mode that you're using.

  For more information, see [Choosing a task mode for your data transfer](https://docs.aws.amazon.com/datasync/latest/userguide/choosing-task-mode.html) .

- `taskReportConfig`: [IResolvable](/cdk/api/v2/docs/aws-cdk-lib.IResolvable.html) | [CfnTask.TaskReportConfigProperty](/cdk/api/v2/docs/aws-cdk-lib.aws_datasync.CfnTask.TaskReportConfigProperty.html) — The configuration of your task report, which provides detailed information about your DataSync transfer.

  For more information, see [Monitoring your DataSync transfers with task reports](https://docs.aws.amazon.com/datasync/latest/userguide/task-reports.html) .

## Properties

- `attrDestinationNetworkInterfaceArns`: string[] — The ARNs of the destination elastic network interfaces (ENIs) that were created for your subnet.

- `attrSourceNetworkInterfaceArns`: string[] — The ARNs of the source ENIs that were created for your subnet.

- `attrStatus`: string — The status of the task that was described.

- `attrTaskArn`: string — The ARN of the task.

- `CFN_RESOURCE_TYPE_NAME`: string (static) — The CloudFormation resource type name for this resource class.

- `cfnOptions`: [ICfnResourceOptions](/cdk/api/v2/docs/aws-cdk-lib.ICfnResourceOptions.html) — Options for this resource, such as condition, update policy etc.

- `cfnResourceType`: string — AWS resource type.

- `cloudWatchLogGroupArn`: string — Specifies the Amazon Resource Name (ARN) of an Amazon CloudWatch log group for monitoring your task.

- `creationStack`: string[]

- `destinationLocationArn`: string — The Amazon Resource Name (ARN) of an AWS storage resource's location.

- `env`: [ResourceEnvironment](/cdk/api/v2/docs/aws-cdk-lib.interfaces.ResourceEnvironment.html)

- `excludes`: [IResolvable](/cdk/api/v2/docs/aws-cdk-lib.IResolvable.html) | [IResolvable](/cdk/api/v2/docs/aws-cdk-lib.IResolvable.html) | [CfnTask.FilterRuleProperty](/cdk/api/v2/docs/aws-cdk-lib.aws_datasync.CfnTask.FilterRuleProperty.html)[] — Specifies exclude filters that define the files, objects, and folders in your source location that you don't want DataSync to transfer.

- `includes`: [IResolvable](/cdk/api/v2/docs/aws-cdk-lib.IResolvable.html) | [IResolvable](/cdk/api/v2/docs/aws-cdk-lib.IResolvable.html) | [CfnTask.FilterRuleProperty](/cdk/api/v2/docs/aws-cdk-lib.aws_datasync.CfnTask.FilterRuleProperty.html)[] — Specifies include filters that define the files, objects, and folders in your source location that you want DataSync to transfer.

- `logicalId`: string — The logical ID for this CloudFormation stack element.

  The logical ID of the element
  is calculated from the path of the resource node in the construct tree.

  To override this value, use `overrideLogicalId(newLogicalId)`.

- `manifestConfig`: [IResolvable](/cdk/api/v2/docs/aws-cdk-lib.IResolvable.html) | [CfnTask.ManifestConfigProperty](/cdk/api/v2/docs/aws-cdk-lib.aws_datasync.CfnTask.ManifestConfigProperty.html) — The configuration of the manifest that lists the files or objects that you want DataSync to transfer.

- `name`: string — Specifies the name of your task.

- `node`: [Node](/cdk/api/v2/docs/constructs.Node.html) — The tree node.

- `options`: [IResolvable](/cdk/api/v2/docs/aws-cdk-lib.IResolvable.html) | [CfnTask.OptionsProperty](/cdk/api/v2/docs/aws-cdk-lib.aws_datasync.CfnTask.OptionsProperty.html) — Specifies your task's settings, such as preserving file metadata, verifying data integrity, among other options.

- `ref`: string — Return a string that will be resolved to a CloudFormation `{ Ref }` for this element.

  If, by any chance, the intrinsic reference of a resource is not a string, you could
  coerce it to an IResolvable through `Lazy.any({ produce: resource.ref })`.

- `schedule`: [IResolvable](/cdk/api/v2/docs/aws-cdk-lib.IResolvable.html) | [CfnTask.TaskScheduleProperty](/cdk/api/v2/docs/aws-cdk-lib.aws_datasync.CfnTask.TaskScheduleProperty.html) — Specifies a schedule for when you want your task to run.

- `sourceLocationArn`: string — Specifies the ARN of your transfer's source location.

- `stack`: [Stack](/cdk/api/v2/docs/aws-cdk-lib.Stack.html) — The stack in which this element is defined.

  CfnElements must be defined within a stack scope (directly or indirectly).

- `tags`: [TagManager](/cdk/api/v2/docs/aws-cdk-lib.TagManager.html) — Tag Manager which manages the tags for this resource.

- `tagsRaw`: [CfnTag](/cdk/api/v2/docs/aws-cdk-lib.CfnTag.html)[] — Specifies the tags that you want to apply to your task.

- `taskMode`: string — The task mode that you're using.

- `taskRef`: [TaskReference](/cdk/api/v2/docs/aws-cdk-lib.interfaces.aws_datasync.TaskReference.html) — A reference to a Task resource.

- `taskReportConfig`: [IResolvable](/cdk/api/v2/docs/aws-cdk-lib.IResolvable.html) | [CfnTask.TaskReportConfigProperty](/cdk/api/v2/docs/aws-cdk-lib.aws_datasync.CfnTask.TaskReportConfigProperty.html) — The configuration of your task report, which provides detailed information about your DataSync transfer.

## Methods

- `addDeletionOverride(path: string): void` — Syntactic sugar for `addOverride(path, undefined)`.

  **Parameters**

  - `path` — The path of the value to delete.

- `addDependency(target: CfnResource): void` — Use `addResourceDependency` instead.

  This method has been renamed to `addResourceDependency` to more clearly
  set it apart from `construct.node.addDependency`. See the documentation
  of that function for more details.

- `addDependsOn(target: CfnResource): void` — Use `addResourceDependency` instead.

  This can be used for resources across stacks (or nested stack) boundaries
  and the dependency will automatically be transferred to the relevant scope.

  This method has been renamed to `addResourceDependency`, which makes it
  more clear that this method operates at a different level from the
  construct-level `construct.node.addDependency()` mechanism.

- `addMetadata(key: string, value: any): void` — Add a value to the CloudFormation Resource Metadata.

- `addOverride(path: string, value: any): void` — Adds an override to the synthesized CloudFormation resource.

  To add a
  property override, either use `addPropertyOverride` or prefix `path` with
  "Properties." (i.e. `Properties.TopicName`).

  If the override is nested, separate each nested level using a dot (.) in the path parameter.
  If there is an array as part of the nesting, specify the index in the path.

  To include a literal `.` in the property name, prefix with a `\`. In most
  programming languages you will need to write this as `"\\."` because the
  `\` itself will need to be escaped.

  For example,
  ```typescript
  cfnResource.addOverride('Properties.GlobalSecondaryIndexes.0.Projection.NonKeyAttributes', ['myattribute']);
  cfnResource.addOverride('Properties.GlobalSecondaryIndexes.1.ProjectionType', 'INCLUDE');
  ```
  would add the overrides
  ```json
  "Properties": {
    "GlobalSecondaryIndexes": [
      {
        "Projection": {
          "NonKeyAttributes": [ "myattribute" ]
          ...
        }
        ...
      },
      {
        "ProjectionType": "INCLUDE"
        ...
      },
    ]
    ...
  }
  ```

  The `value` argument to `addOverride` will not be processed or translated
  in any way. Pass raw JSON values in here with the correct capitalization
  for CloudFormation. If you pass CDK classes or structs, they will be
  rendered with lowercased key names, and CloudFormation will reject the
  template.

  **Parameters**

  - `path` — - The path of the property, you can use dot notation to override values in complex types.
  - `value` — - The value.

- `addPropertyDeletionOverride(propertyPath: string): void` — Adds an override that deletes the value of a property from the resource definition.

  **Parameters**

  - `propertyPath` — The path to the property.

- `addPropertyOverride(propertyPath: string, value: any): void` — Adds an override to a resource property.

  Syntactic sugar for `addOverride("Properties.<...>", value)`.

  **Parameters**

  - `propertyPath` — The path of the property.
  - `value` — The value.

- `addResourceDependency(target: CfnResource, reason?: string): void` — Indicates that this resource depends on another resource and cannot be provisioned unless the other resource has been successfully provisioned.

  This can be used for resources across stacks (or nested stack) boundaries
  and the dependency will automatically be transferred to the relevant scope.

  This method only adds dependencies between L1 resources. If you are
  looking for a generic construct-to-construct dependency mechanism that works
  for all constructs including L2s, use `construct.node.addDependency` instead.

- `applyCrossStackReferenceStrength(strength: ReferenceStrength): void` — Sets the cross-stack reference strength for this resource.

  When set, any cross-stack reference to this resource will use the specified
  strength instead of the global default from the consuming stack's context.

  **Parameters**

  - `strength` — - The reference strength to use for this resource.

- `applyRemovalPolicy(policy?: RemovalPolicy, options?: RemovalPolicyOptions): void` — Sets the deletion policy of the resource based on the removal policy specified.

  The Removal Policy controls what happens to this resource when it stops
  being managed by CloudFormation, either because you've removed it from the
  CDK application or because you've made a change that requires the resource
  to be replaced.

  The resource can be deleted (`RemovalPolicy.DESTROY`), or left in your AWS
  account for data recovery and cleanup later (`RemovalPolicy.RETAIN`). In some
  cases, a snapshot can be taken of the resource prior to deletion
  (`RemovalPolicy.SNAPSHOT`). A list of resources that support this policy
  can be found in the following link:

- `arnForTask(resource: ITaskRef): string` (static)

- `cfnPropertyName(cdkPropertyName: string): string`

- `getAtt(attributeName: string, typeHint?: ResolutionTypeHint): Reference` — Returns a token for an runtime attribute of this resource.

  Ideally, use generated attribute accessors (e.g. `resource.arn`), but this can be used for future compatibility
  in case there is no generated attribute.

  **Parameters**

  - `attributeName` — The name of the attribute.

- `getMetadata(key: string): any` — Retrieve a value value from the CloudFormation Resource Metadata.

- `inspect(inspector: TreeInspector): void` — Examines the CloudFormation resource and discloses attributes.

  **Parameters**

  - `inspector` — tree inspector to collect and process attributes.

- `isCfnElement(x: any): boolean` (static) — Returns `true` if a construct is a stack element (i.e. part of the synthesized cloudformation template).

  Uses duck-typing instead of `instanceof` to allow stack elements from different
  versions of this library to be included in the same stack.

  **Returns:** The construct as a stack element or undefined if it is not a stack element.

- `isCfnResource(x: any): boolean` (static) — Check whether the given object is a CfnResource.

- `isCfnTask(x: any): boolean` (static) — Checks whether the given object is a CfnTask.

- `isConstruct(x: any): boolean` (static) — Checks if `x` is a construct.

  Use this method instead of `instanceof` to properly detect `Construct`
  instances, even when the construct library is symlinked.

  Explanation: in JavaScript, multiple copies of the `constructs` library on
  disk are seen as independent, completely different libraries. As a
  consequence, the class `Construct` in each copy of the `constructs` library
  is seen as a different class, and an instance of one class will not test as
  `instanceof` the other class. `npm install` will not create installations
  like this, but users may manually symlink construct libraries together or
  use a monorepo tool: in those cases, multiple copies of the `constructs`
  library can be accidentally installed, and `instanceof` will behave
  unpredictably. It is safest to avoid using `instanceof`, and using
  this type-testing method instead.

  **Parameters**

  - `x` — Any object.

  **Returns:** true if `x` is an object created from a class which extends `Construct`.

- `obtainDependencies(): Stack | CfnResource[]` — Retrieves an array of resources and stacks this resource depends on.

  For resources depended on directly, returns the `CfnResource` object. For
  dependencies on other stacks, returns the `Stack` object. The order of the
  array is not guaranteed.

- `overrideLogicalId(newLogicalId: string): void` — Overrides the auto-generated logical ID with a specific ID.

  **Parameters**

  - `newLogicalId` — The new logical ID to use for this stack element.

- `removeDependency(target: CfnResource): void` — Use `removeResourceDependency` instead

  This can be used for resources across stacks (including nested stacks)
  and the dependency will automatically be removed from the relevant scope.

- `removeResourceDependency(target: CfnResource): void` — Indicates that this resource no longer depends on another resource.

  This can be used for resources across stacks (including nested stacks)
  and the dependency will automatically be removed from the relevant scope.

- `replaceDependency(target: CfnResource, newTarget: CfnResource): void` — Replaces one dependency with another.

  **Parameters**

  - `target` — The dependency to replace.
  - `newTarget` — The new dependency to add.

- `toString(): string` — Returns a string representation of this construct.

  **Returns:** a string representation of this resource

- `with(...mixins: IMixin[]): IConstruct` — Applies one or more mixins to this construct.

  Mixins are applied in order. The list of constructs is captured at the
  start of the call, so constructs added by a mixin will not be visited.
  Use multiple `with()` calls if subsequent mixins should apply to added
  constructs.
